import type { BalanceResponse, BeeRequestOptions, PeerBalance } from '../../types';
import { PeerAddress } from '../../utils/typed-bytes';
/**
 * Get the balances with all known peers including prepaid services
 *
 * @param requestOptions Options for making requests
 */
export declare function getAllBalances(requestOptions: BeeRequestOptions): Promise<BalanceResponse>;
/**
 * Get the balances with a specific peer including prepaid services
 *
 * @param requestOptions Options for making requests
 * @param address Swarm address of peer
 */
export declare function getPeerBalance(requestOptions: BeeRequestOptions, address: PeerAddress): Promise<PeerBalance>;
/**
 * Get the past due consumption balances with all known peers
 *
 * @param requestOptions Options for making requests
 */
export declare function getPastDueConsumptionBalances(requestOptions: BeeRequestOptions): Promise<BalanceResponse>;
/**
 * Get the past due consumption balance with a specific peer
 *
 * @param requestOptions Options for making requests
 * @param address Swarm address of peer
 */
export declare function getPastDueConsumptionPeerBalance(requestOptions: BeeRequestOptions, address: PeerAddress): Promise<PeerBalance>;
