import type { BeeRequestOptions, Bin, NodeAddresses, Peer, PingResponse, RemovePeerResponse, Topology } from '../../types';
import { PeerAddress } from '../../utils/typed-bytes';
export declare function getNodeAddresses(requestOptions: BeeRequestOptions): Promise<NodeAddresses>;
export declare function getPeers(requestOptions: BeeRequestOptions): Promise<Peer[]>;
export declare function getBlocklist(requestOptions: BeeRequestOptions): Promise<Peer[]>;
export declare function removePeer(requestOptions: BeeRequestOptions, peer: PeerAddress): Promise<RemovePeerResponse>;
export declare function getTopology(requestOptions: BeeRequestOptions): Promise<Topology>;
export declare function pingPeer(requestOptions: BeeRequestOptions, peer: PeerAddress): Promise<PingResponse>;
export declare function asBin(value: unknown, name: string): Bin;
