import type { AllSettlements, BeeRequestOptions, Settlements } from '../../types';
import { PeerAddress } from '../../utils/typed-bytes';
/**
 * Get amount of sent and received from settlements with a peer
 *
 * @param requestOptions Options for making requests
 * @param peer  Swarm address of peer
 */
export declare function getSettlements(requestOptions: BeeRequestOptions, peer: PeerAddress): Promise<Settlements>;
/**
 * Get settlements with all known peers and total amount sent or received
 *
 * @param requestOptions Options for making requests
 */
export declare function getAllSettlements(requestOptions: BeeRequestOptions): Promise<AllSettlements>;
