import type { BeeRequestOptions, Pin } from '../types';
import { Reference } from '../utils/typed-bytes';
/**
 * Pin data with given reference
 *
 * @param requestOptions Options for making requests
 * @param reference Bee data reference
 */
export declare function pin(requestOptions: BeeRequestOptions, reference: Reference): Promise<void>;
/**
 * Unpin data with given reference
 *
 * @param requestOptions Options for making requests
 * @param reference Bee data reference
 */
export declare function unpin(requestOptions: BeeRequestOptions, reference: Reference): Promise<void>;
/**
 * Get pin status for specific address.
 *
 * @param requestOptions Options for making requests
 * @param reference
 * @throws Error if given address is not pinned
 */
export declare function getPin(requestOptions: BeeRequestOptions, reference: Reference): Promise<Pin>;
/**
 * Get list of all pins
 *
 * @param requestOptions Options for making requests
 */
export declare function getAllPins(requestOptions: BeeRequestOptions): Promise<Reference[]>;
