import { BeeRequestOptions, Tag } from '../types';
import { Reference } from '../utils/typed-bytes';
/**
 * Create new tag on the Bee node
 *
 * @param url Bee tag URL
 */
export declare function createTag(requestOptions: BeeRequestOptions): Promise<Tag>;
/**
 * Retrieve tag information from Bee node
 *
 * @param url Bee tag URL
 * @param uid UID of tag to be retrieved
 */
export declare function retrieveTag(requestOptions: BeeRequestOptions, uid: number): Promise<Tag>;
/**
 * Get limited listing of all tags.
 *
 * @param url
 * @param offset
 * @param limit
 */
export declare function getAllTags(requestOptions: BeeRequestOptions, offset?: number, limit?: number): Promise<Tag[]>;
/**
 * Removes tag from the Bee node.
 * @param url
 * @param uid
 */
export declare function deleteTag(requestOptions: BeeRequestOptions, uid: number): Promise<void>;
/**
 * Updates tag
 * @param url
 * @param uid
 * @param reference
 */
export declare function updateTag(requestOptions: BeeRequestOptions, uid: number, reference: Reference): Promise<void>;
