import { RedundancyLevel } from '..';
/**
 * Returns an approximate multiplier for the overhead of a given redundancy level.
 * Redundancy level is a tradeoff between storage overhead and fault tolerance.
 * Use this number to estimate the amount of chunks that will be stored for a given
 * redundancy level.
 */
export declare function approximateOverheadForRedundancyLevel(chunks: number, level: RedundancyLevel, encrypted: boolean): number;
interface RedundancyStats {
    label: string;
    value: RedundancyLevel;
    errorTolerance: number;
}
export declare function getRedundancyStats(): {
    medium: RedundancyStats;
    strong: RedundancyStats;
    insane: RedundancyStats;
    paranoid: RedundancyStats;
};
export declare function getRedundancyStat(level?: string | RedundancyLevel): RedundancyStats;
export {};
