/**
 * Represents a size in bytes.
 *
 * Uses 1000 instead of 1024 for converting between units.
 * This is to stay consistent with the Swarm papers
 * on theoretical and effective storage capacity.
 */
export declare class Size {
    private bytes;
    private constructor();
    static fromBytes(bytes: number): Size;
    static fromKilobytes(kilobytes: number): Size;
    static fromMegabytes(megabytes: number): Size;
    static fromGigabytes(gigabytes: number): Size;
    toBytes(): number;
    toGigabytes(): number;
    toFormattedString(): string;
}
